<?xml version="1.0" encoding="UTF-8"?>

<!--
 *
 * This help file was generated from sudoku_findtwocolors.sci using help_from_sci().
 *
 -->

<refentry version="5.0-subset Scilab" xml:id="sudoku_findtwocolors" xml:lang="en"
          xmlns="http://docbook.org/ns/docbook"
          xmlns:xlink="http://www.w3.org/1999/xlink"
          xmlns:svg="http://www.w3.org/2000/svg"
          xmlns:ns3="http://www.w3.org/1999/xhtml"
          xmlns:mml="http://www.w3.org/1998/Math/MathML"
          xmlns:db="http://docbook.org/ns/docbook">


  <refnamediv>
    <refname>sudoku_findtwocolors</refname><refpurpose>Search for pairs.</refpurpose>
  </refnamediv>



<refsynopsisdiv>
   <title>Calling Sequence</title>
   <synopsis>
   X = sudoku_findtwocolors ( X , C , L )
   X = sudoku_findtwocolors ( X , C , L , stopatfirst )
   X = sudoku_findtwocolors ( X , C , L , stopatfirst , verbose )
   [ X , C ] = sudoku_findtwocolors ( ... )
   [ X , C , L ] = sudoku_findtwocolors ( ... )
   
   </synopsis>
</refsynopsisdiv>

<refsection>
   <title>Parameters</title>
   <variablelist>
   <varlistentry><term>X:</term>
      <listitem><para> a 9-by-9 matrix, with 0 for unknown entries</para></listitem></varlistentry>
   <varlistentry><term>C:</term>
      <listitem><para> a 9 x 9 cell of candidates</para></listitem></varlistentry>
   <varlistentry><term>L:</term>
      <listitem><para> the 9 x 9 matrix of number candidates</para></listitem></varlistentry>
   <varlistentry><term>stopatfirst:</term>
      <listitem><para> if %t, then stop when one or more candidates have been removed. (default = %t)</para></listitem></varlistentry>
   <varlistentry><term>verbose:</term>
      <listitem><para> a boolean. Set to %t to display the state of the matrix. (default = %f)</para></listitem></varlistentry>
   </variablelist>
</refsection>

<refsection>
   <title>Description</title>
   <para>
Color the sudoku with 2 colors and find inconsistencies.
The algorithm is the following:
* compute conjugate pairs (i.e. pairs of two cells which
are the only 2 candidates in their rows, columns or blocks),
* add coloring with 2 colors,
* make deductions:
* strategy #1 : if there are two colored cells with color X
in the same row, column or block, remove the candidate d in these cells,
* strategy #2 : if there exist one uncolored cell A visible by two colored
cells, then A is not a candidate of the uncolored cell.
The Turbot-fish strategy is superseded by the 2-colors strategy.
   </para>
   <para>
</para>
</refsection>

<refsection>
   <title>Examples</title>
   <programlisting role="example"><![CDATA[

X = [
1 9 6   4 5 3   7 2 8
4 3 0   7 6 0   9 5 1
0 5 7   0 1 9   4 6 3
..
3 6 5   9 8 7   1 4 2
9 8 4   1 2 5   6 3 7
7 2 1   6 3 4   8 9 5
..
6 7 0   0 4 1   5 8 9
0 4 9   0 7 0   3 1 6
0 1 0   0 9 6   2 7 4
];
[C,L] = sudoku_candidates(X);
X = sudoku_findtwocolors ( X , C , L , %f , %t );

   ]]></programlisting>
</refsection>

<refsection>
   <title>Authors</title>
   <simplelist type="vert">
   <member>Michael Baudin, 2010-2011</member>
   </simplelist>
</refsection>

<refsection>
   <title>Bibliography</title>
   <para>Angus Johnson, http://www.angusj.com/sudoku/hints.php</para>
</refsection>
</refentry>
